<template>
  <div class="row mt-4 striped to-stripe">
    <div class="col-1">
      <div class="aspect-box overflow-hidden">
        <div class="aspect-container">
          <img
            :src="
              baseUrl + '/media/image/' + eventEntry.imageId + '?maxWidth=150'
            "
            class="w-100"
          />
        </div>
      </div>
    </div>
    <div class="col">
      <div class="font-weight-bold">{{ eventEntry.titleInternal }}</div>

      <div>
        title:
        <span v-for="lang in languages" :key="lang">
          <span
            v-if="!eventEntry.title[lang] || eventEntry.title[lang] === ''"
            class="mr-2"
          >
            <font-awesome-icon
              :icon="['fas', 'exclamation-triangle']"
              :class="{
                'text-warning': fallbackLanguage !== lang,
                'text-danger': fallbackLanguage === lang,
              }"
              class="mr-1"
            ></font-awesome-icon
            >{{ lang }}
          </span>
        </span>
      </div>
      <div>
        teaser:
        <span v-for="lang in languages" :key="lang">
          <span
            v-if="
              !eventEntry.description[lang] ||
                eventEntry.description[lang] === ''
            "
            class="mr-2"
          >
            <font-awesome-icon
              :icon="['fas', 'exclamation-triangle']"
              :class="{
                'text-warning': fallbackLanguage !== lang,
                'text-danger': fallbackLanguage === lang,
              }"
              class="mr-1"
            ></font-awesome-icon
            >{{ lang }}
          </span>
        </span>
      </div>
    </div>
    <div class="col">
      <div>
        Start: {{ formatDateShort(eventEntry.dateStart) }}
        <font-awesome-icon
          v-if="!eventEntry.dateStart || eventEntry.dateStart === ''"
          :icon="['fas', 'exclamation-triangle']"
          class="text-danger"
        ></font-awesome-icon>
      </div>
      <div>
        End: {{ formatDateShort(eventEntry.dateEnd) }}
        <font-awesome-icon
          v-if="!eventEntry.dateEnd || eventEntry.dateEnd === ''"
          :icon="['fas', 'exclamation-triangle']"
          class="text-danger"
        ></font-awesome-icon>
      </div>
    </div>
    <div class="col">
      <div>box: {{ eventEntry.preferredSize }}</div>
      <div>lock size: {{ eventEntry.lockSize }}</div>
    </div>
    <div class="col">
      <div v-if="!eventEntry.linkTo || eventEntry.linkTo === ''">
        <font-awesome-icon
          :icon="['fas', 'exclamation-triangle']"
          class="text-danger"
        ></font-awesome-icon>
      </div>
      <a v-else :href="eventEntry.linkTo" target="_blank"
        >{{ eventEntry.linkTo }}
        <font-awesome-icon :icon="['fas', 'external-link-alt']"
      /></a>
    </div>
    <div class="col-2 pt-1 pb-1 text-nowrap text-right">
      <b-button
        v-if="!eventEntry.published && canPublish"
        @click="onPublish()"
        :disabled="!isPublishable"
        variant="info"
      >
        <font-awesome-icon :icon="['fas', 'eye']" /> publish
      </b-button>
      <b-button v-else-if="canPublish" @click="onUnpublish()" variant="warning">
        <font-awesome-icon :icon="['fas', 'eye-slash']" /> unpublish
      </b-button>
      <b-button @click="onEdit()" variant="success">
        <font-awesome-icon :icon="['fas', 'pencil-alt']" />
      </b-button>
      <b-button
        @click="onDelete()"
        v-if="!eventEntry.published && canDelete"
        variant="danger"
      >
        <font-awesome-icon :icon="['fas', 'trash']" />
      </b-button>
    </div>
  </div>
</template>

<script>
import DateTimeFormatMixin from '~/components/mixins/DateTimeFormatMixin';
import AuthorizedMixin from '~/components/security/AuthorizedMixin';

export default {
  mixins: [DateTimeFormatMixin, AuthorizedMixin],
  props: {
    eventEntry: {
      type: Object,
      default: null,
    },
    languages: {
      type: Array,
      default: () => {
        return [];
      },
    },
    fallbackLanguage: {
      type: String,
      default: 'en',
    },
  },
  computed: {
    canPublish() {
      return this.isAuthorized(['EVENT_PUBLISH']);
    },
    canDelete() {
      return this.isAuthorized(['EVENT_DELETE']);
    },
    _hasImage() {
      return this.eventEntry.imageId && this.eventEntry.imageId > 0;
    },
    _hasTitleFallbackLang() {
      return (
        this.eventEntry.title &&
        this._notEmpty(this.eventEntry.title[this.fallbackLanguage])
      );
    },
    _hasTeaserFallbackLang() {
      return (
        this.eventEntry.description &&
        this._notEmpty(this.eventEntry.description[this.fallbackLanguage])
      );
    },
    isPublishable() {
      return (
        this.eventEntry &&
        this.eventEntry.title &&
        this._hasTitleFallbackLang &&
        this._hasTeaserFallbackLang &&
        // this._hasAllLang &&
        this._notEmpty(this.eventEntry.dateStart) &&
        this._notEmpty(this.eventEntry.dateEnd) &&
        this._notEmpty(this.eventEntry.linkTo) &&
        this._notEmpty(this.eventEntry.preferredSize) &&
        this.lockSize !== null &&
        this._hasImage
      );
    },
    baseUrl() {
      return process.env.baseURL;
    },
  },
  methods: {
    _notEmpty(what) {
      return what && what !== '';
    },
    onEdit() {
      this.$emit('edit-entry', this.eventEntry);
    },
    onDelete() {
      this.$emit('delete-entry', this.eventEntry);
    },
    onPublish() {
      this.$emit('publish-entry', this.eventEntry);
    },
    onUnpublish() {
      this.$emit('unpublish-entry', this.eventEntry);
    },
  },
};
</script>
